install 9.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. debianOS=false
  13. rhelOS=false
  14. OS=$(uname -s)
  15. if [ $OS = "Linux" ]; then
  16. OS="GNU/Linux"
  17. if [ -f /etc/os-release ]; then
  18. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  20. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  21. for i in $ID_LIKE; do
  22. #printf "$i\n"
  23. case $i in
  24. debian|ubuntu)
  25. debianOS=true
  26. break
  27. ;;
  28. rhel|fedora)
  29. rhelOS=true
  30. break
  31. ;;
  32. *)
  33. debianOS=false
  34. rhelOS=false
  35. ;;
  36. esac
  37. done
  38. elif [ -f /etc/debian-version ]; then
  39. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  40. DIST="Debian"
  41. REV=""
  42. ID_LIKE="debian"
  43. debianOS=true
  44. elif [ -f /etc/redhat-release ]; then
  45. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  46. DIST="Red-Hat"
  47. REV=""
  48. ID_LIKE="rhel"
  49. rhelOS=true
  50. else
  51. # Other Linux (No Soportado)
  52. DIST=""
  53. REV=""
  54. ID_LIKE=""
  55. fi
  56. else
  57. # UNIX, OS X, ... (No Soportado)
  58. DIST=$OS
  59. REV=""
  60. fi
  61. #printf " $DIST $REV\n"
  62. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  63. }
  64. comprobarRoot() {
  65. if [ $(id -u) -ne 0 ]; then
  66. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  67. exit 1
  68. fi
  69. }
  70. comprobarDependencias() {
  71. which whiptail > /dev/null 2>&1
  72. if [ $? -ne 0 ];then
  73. printf "ERROR:\t'whiptail' no disponible.\n"
  74. exit 1
  75. fi
  76. which hostnamectl > /dev/null 2>&1
  77. if [ $? -ne 0 ];then
  78. printf "ERROR:\t'hostnamectl' no disponible.\n"
  79. exit 1
  80. fi
  81. if [ $debianOS = true ];then
  82. which apt-get > /dev/null 2>&1
  83. if [ $? -ne 0 ]; then
  84. printf "ERROR:\t'apt-get' no está disponible.\n"
  85. exit 1
  86. fi
  87. #Actualizamos base de datos del repositorio
  88. printf "Actualizando repositorio APT..."
  89. result=$(apt-get -q -y update)
  90. if [ $? -ne 0 ]; then
  91. printf "\nERROR:\tImposible actualizar repositorio.\n"
  92. printf "Detalles:\n$result\n"
  93. exit 1
  94. fi
  95. printf " OK.\n"
  96. fi
  97. if [ $rhelOS = true ]; then
  98. which yum > /dev/null 2>&1
  99. if [ $? -ne 0 ]; then
  100. printf "ERROR:\t'yum' no está disponible.\n"
  101. exit 1
  102. fi
  103. printf "Actualizando repositorio YUM..."
  104. result=$(yum -y makecache 2>&1)
  105. if [ $? -ne 0 ]; then
  106. printf "\nERROR:\tImposible actualizar repositorio.\n"
  107. printf "Detalles:\n$result\n"
  108. exit 1
  109. fi
  110. printf " OK.\n"
  111. fi
  112. }
  113. comprobarHostname() {
  114. while [ -z $hostname ]; do
  115. hostname=$(whiptail --title "Hostname" --inputbox "El nombre de dominio de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" --ok-button "Cambiar" --cancel-button "No Cambiar" 20 70 3>&1 1>&2 2>&3)
  116. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  117. hostnamectl set-hostname $hostname
  118. else
  119. hostname=$(hostname)
  120. fi
  121. done
  122. #printf "\nHostname: $hostname\n"
  123. }
  124. mostrarBienvenida() {
  125. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  126. whiptail --title "ERROR OS NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --ok-button "Salir" 20 70
  127. exit 1
  128. fi
  129. whiptail --title "Instalación MediaWiki" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --yes-button "Continuar" --no-button "Salir" 20 70
  130. if [ $? -ne 0 ]; then
  131. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  132. exit 2
  133. fi
  134. }
  135. mostrarComponentes() {
  136. componentes=$(whiptail --title "Instalación" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 5 \
  137. "WebServer" "Instalar servidor web http/https" ON \
  138. "Database" "Instalar una base de datos SQL" ON \
  139. "PHP" "Instala PHP7" ON \
  140. "SSL/TLS" "Instala certificados para activar HTTPS" ON \
  141. "MediaWiki" "Instala la última versión de MediaWiki" ON \
  142. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  143. if [ $? -ne 0 ]; then
  144. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  145. exit 2
  146. fi
  147. # Mejora: autodetección de componentes ya instalados
  148. for i in $componentes; do
  149. case $i in
  150. \"WebServer\")
  151. printf "Instalando Servidor Web"
  152. instalarWebServer
  153. printf " OK.\n"
  154. ;;
  155. \"Database\")
  156. printf "Instalando Servidor Database"
  157. instalarDatabase
  158. printf " OK.\n"
  159. ;;
  160. \"PHP\")
  161. printf "Instalando PHP..."
  162. printf " OK.\n"
  163. ;;
  164. \"SSL/TLS\")
  165. printf "Instalando SSL/TLS..."
  166. printf " OK.\n"
  167. ;;
  168. \"MediaWiki\")
  169. printf "Instalando MediaWiki..."
  170. printf " OK.\n"
  171. ;;
  172. *)
  173. printf "ERROR:\tError interno (selección de componentes).\n"
  174. exit 1
  175. ;;
  176. esac
  177. done
  178. }
  179. instalarWebServer() {
  180. webServer=$(whiptail --title "Servidor Web" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  181. "Apache" "Instalar el servidor web Apache2" ON \
  182. "Nginx" "Instalar el servidor web Nginx" OFF \
  183. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  184. if [ $? -ne 0 ]; then
  185. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  186. exit 2
  187. fi
  188. # Preguntar otras opciones de configuración
  189. comprobarHostname
  190. case $webServer in
  191. Apache)
  192. printf " Apache..."
  193. instalarApache
  194. ;;
  195. Nginx)
  196. printf " Nginx..."
  197. instalarNginx
  198. ;;
  199. *)
  200. printf "\nERROR:\tError interno (selección de web server).\n"
  201. exit 1
  202. ;;
  203. esac
  204. }
  205. instalarApache() {
  206. if [ $debianOS = true ];then
  207. result=$(apt-get -q -y install apache2 2>&1)
  208. if [ $? -ne 0 ]; then
  209. printf "\nERROR:\tError al instalar apache2.\n"
  210. printf "Detalles:\n$result\n"
  211. exit 1
  212. fi
  213. elif [ $rhelOS = true ]; then
  214. result=$(yum -y install httpd 2>&1)
  215. if [ $? -ne 0 ]; then
  216. printf "\nERROR:\tError al instalar apache2.\n"
  217. printf "Detalles:\n$result\n"
  218. exit 1
  219. fi
  220. else
  221. printf "\nERROR:\tError interno (instalación apache).\n"
  222. exit 1
  223. fi
  224. }
  225. instalarNginx() {
  226. if [ $debianOS = true ];then
  227. result=$(apt-get -q -y install nginx 2>&1)
  228. if [ $? -ne 0 ]; then
  229. printf "\nERROR:\tError al instalar apache2.\n"
  230. printf "Detalles:\n$result\n"
  231. exit 1
  232. fi
  233. elif [ $rhelOS = true ]; then
  234. # Hay que instalar primero otro repositorio
  235. result=$(yum -y install nginx 2>&1)
  236. if [ $? -ne 0 ]; then
  237. printf "\nERROR:\tError al instalar apache2.\n"
  238. printf "Detalles:\n$result\n"
  239. exit 1
  240. fi
  241. else
  242. printf "\nERROR:\tError interno (instalación apache).\n"
  243. exit 1
  244. fi
  245. }
  246. instalarDatabase() {
  247. if [ $debianOS = true ]; then
  248. database=$(whiptail --title "Base de Datos" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  249. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  250. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  251. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  252. if [ $? -ne 0 ]; then
  253. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  254. exit 2
  255. fi
  256. # Preguntar otras opciones de configuración
  257. case $database in
  258. MySQL)
  259. printf " MySQL..."
  260. instalarMySQL
  261. ;;
  262. MariaDB)
  263. printf " MariaDB..."
  264. instalarMariaDB
  265. ;;
  266. *)
  267. printf "\nERROR:\tError interno (selección de base de datos).\n"
  268. exit 1
  269. ;;
  270. esac
  271. elif [ $rhelOS = true ]; then
  272. whiptail --title "Base de Datos" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." --yes-button "Continuar" --no-button "Salir" 20 70
  273. if [ $? -ne 0 ]; then
  274. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  275. exit 2
  276. fi
  277. printf " MariaDB.."
  278. instalarMariaDB
  279. else
  280. printf "\nERROR:\tError interno (instalación Base de Datos).\n"
  281. exit 1
  282. fi
  283. }
  284. instalarMySQL() {
  285. if [ $debianOS = true ];then
  286. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  287. if [ $? -ne 0 ]; then
  288. printf "\nERROR:\tError al instalar MySQL.\n"
  289. printf "Detalles:\n$result\n"
  290. exit 1
  291. fi
  292. elif [ $rhelOS = true ]; then
  293. # MySQL no disponible en RHEL. 2 opciones_
  294. # 1) Instalar un repositorio adicional
  295. # 2) No instalar MySQL no distribuciones RHEL
  296. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  297. exit 1
  298. else
  299. printf "\nERROR:\tError interno (instalación MySQL).\n"
  300. exit 1
  301. fi
  302. }
  303. instalarMariaDB() {
  304. if [ $debianOS = true ];then
  305. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  306. if [ $? -ne 0 ]; then
  307. printf "\nERROR:\tError al instalar MariaDB.\n"
  308. printf "Detalles:\n$result\n"
  309. exit 1
  310. fi
  311. elif [ $rhelOS = true ]; then
  312. result=$(yum -y install mariadb-server 2>&1)
  313. if [ $? -ne 0 ]; then
  314. printf "\nERROR:\tError al instalar MariaDB.\n"
  315. printf "Detalles:\n$result\n"
  316. exit 1
  317. fi
  318. else
  319. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  320. exit 1
  321. fi
  322. }
  323. # Comprobamos
  324. comprobarRoot
  325. OSInfo
  326. comprobarDependencias
  327. # Bienvenida
  328. mostrarBienvenida
  329. # Mejora: instalación express vs instalación avanzada
  330. # Selección de componentes
  331. mostrarComponentes
  332. # Autodestrucción
  333. {
  334. for i in $(seq 0 5 50); do
  335. sleep 0.1
  336. echo $i
  337. done
  338. } | whiptail --gauge "Autodestrucción..." 7 70 0
  339. {
  340. for i in $(seq 50 5 100); do
  341. sleep 0.1
  342. echo $i
  343. done
  344. } | whiptail --gauge "Autopulverización..." 7 70 50